diff -uNrd ircd-ratbox-1.3-1/src/s_auth.c ircd-ratbox-1.3-1+fr-ssl/src/s_auth.c
--- ircd-ratbox-1.3-1/src/s_auth.c	Tue Sep  2 15:58:01 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/s_auth.c	Sat Jan 24 13:02:25 2004
@@ -54,6 +54,7 @@
 #include "send.h"
 #include "memory.h"
 #include "config.h"
+#include "db.h"
 
 /*
  * a bit different approach
@@ -93,8 +94,18 @@
 }
 ReportType;
 
+#ifdef HAVE_LIBCRYPTO
 #define sendheader(c, r) \
-   send((c)->localClient->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
+   if (IsSSL(c)) \
+     safe_SSL_write(c, HeaderMessages[(r)].message, HeaderMessages[(r)].length); \
+   else \
+     send((c)->localClient->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
+#else
+#define sendheader(c, r) \
+    send((c)->localClient->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
+#endif
+//#define sendheader(c, r) \
+//   send((c)->localClient->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
 
 static dlink_list auth_poll_list;
 static BlockHeap *auth_heap;
diff -uNrd ircd-ratbox-1.3-1/src/s_bsd.c ircd-ratbox-1.3-1+fr-ssl/src/s_bsd.c
--- ircd-ratbox-1.3-1/src/s_bsd.c	Wed Oct 15 09:34:04 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/s_bsd.c	Sat Jan 24 17:15:40 2004
@@ -50,6 +50,7 @@
 #include "s_debug.h"
 #include "memory.h"
 #include "reject.h"
+#include "db.h"
 
 #ifndef IN_LOOPBACKNET
 #define IN_LOOPBACKNET        0x7f
@@ -72,6 +73,7 @@
 static PF comm_connect_timeout;
 static void comm_connect_dns_callback(void *vptr, adns_answer * reply);
 static PF comm_connect_tryconnect;
+static void comm_tryssl_callback(int fd, void *data);
 
 /* close_all_connections() can be used *before* the system come up! */
 
@@ -359,6 +361,9 @@
 
 	socklen_t len = sizeof(struct irc_sockaddr);
 	struct irc_sockaddr irn;
+#ifdef HAVE_LIBCRYPTO
+  int new_ssl = 0;
+#endif 
 	s_assert(NULL != listener);
 
 	/* 
@@ -415,13 +420,60 @@
 	new_client->localClient->listener = listener;
 	++listener->ref_count;
 
+#ifdef HAVE_LIBCRYPTO
+  if ((listener->is_ssl) && !(new_client->ssl))
+  {
+    new_ssl = 1;
+
+    /*SSL client init */
+    if((new_client->ssl = SSL_new(ServerInfo.ctx)) == NULL)
+    {
+      dlink_node * m;
+      m = dlinkFind(&unknown_list, new_client);
+      if (m)
+        dlinkDeleteNode(m, &unknown_list);
+      report_error(L_ALL, "Could not create new ssl connection %s :%s",
+          get_listener_name(listener), errno);
+	  sendto_realops_flags (UMODE_DEBUG, L_ALL, "Could not create new ssl connection %s :%s", get_listener_name(listener), errno);
+      ServerStats->is_ref++;
+      free_client(new_client);
+      return;
+    }
+    SetSSL(new_client);
+	sendto_realops_flags (UMODE_DEBUG, L_ALL, "Created new ssl connection %s", get_listener_name(listener));
+  }
+#endif
+
 	if(!set_non_blocking(new_client->localClient->fd))
 		report_error(L_ALL, NONB_ERROR_MSG, get_client_name(new_client, SHOW_IP), errno);
 	if(!disable_sock_options(new_client->localClient->fd))
 		report_error(L_ALL, OPT_ERROR_MSG, get_client_name(new_client, SHOW_IP), errno);
 	if(check_reject(new_client))
 		return;
-	start_auth(new_client);
+	//start_auth(new_client);
+
+#ifdef HAVE_LIBCRYPTO
+  if (IsSSL(new_client) && new_ssl)
+  {
+	sendto_realops_flags (UMODE_DEBUG, L_ALL, "Accepting SSL connection %s", get_listener_name(listener));
+    SSL_set_fd(new_client->ssl, new_client->localClient->fd);
+    if (!safe_SSL_accept(new_client, new_client->localClient->fd))
+    {
+	  dlink_node * m;
+      sendto_realops_flags (UMODE_DEBUG, L_ALL, "Unsafe acception on %s", get_listener_name(listener));
+      m = dlinkFind(&unknown_list, new_client);
+      if (m)
+        dlinkDeleteNode(m, &unknown_list);
+      SSL_set_shutdown(new_client->ssl, SSL_RECEIVED_SHUTDOWN);
+      SSL_smart_shutdown(new_client->ssl);
+      SSL_free(new_client->ssl);
+      ServerStats->is_ref++;
+      free_client(new_client);
+      return;
+    }
+  }
+#endif
+  comm_setselect(fd, FDLIST_SERVER, COMM_SELECT_WRITE, comm_tryssl_callback, new_client, 0);
 }
 
 
@@ -896,4 +948,42 @@
 
 	/* .. and return */
 	return newfd;
+}
+
+static void
+comm_tryssl_callback(int fd, void *data)
+{
+  int doauth = -1;
+  struct Client *new_client = data;
+
+  fdlist_t fdlist = FDLIST_NONE;
+
+  fdlist = FDLIST_SERVER;
+  doauth = 1;
+
+#ifdef HAVE_LIBCRYPTO
+  if (IsSSL(new_client))
+  {
+    if (!SSL_is_init_finished(new_client->ssl))
+    {
+      if (!safe_SSL_accept(new_client, new_client->localClient->fd))
+      {
+        //dead_link_on_read(new_client, errno);
+		sendto_realops_flags (UMODE_DEBUG, L_ALL, "Unsafe acception.");
+        return;
+      }
+      else
+      {
+        comm_setselect(fd, fdlist, COMM_SELECT_WRITE, comm_tryssl_callback, new_client, 0);
+        return;
+      }
+    }
+  }
+#endif
+
+  if (doauth == 1)
+  {
+    sendto_realops_flags (UMODE_DEBUG, L_ALL, "Starting Auth"); 
+    start_auth(new_client);
+  }
 }
diff -uNrd ircd-ratbox-1.3-1/src/send.c ircd-ratbox-1.3-1+fr-ssl/src/send.c
--- ircd-ratbox-1.3-1/src/send.c	Mon Dec  1 14:00:10 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/send.c	Sat Jan 24 20:18:44 2004
@@ -45,6 +45,7 @@
 #include "s_log.h"
 #include "memory.h"
 #include "hook.h"
+#include "db.h"
 
 #define LOG_BUFSIZE 2048
 
@@ -264,7 +265,7 @@
 	if(linebuf_len(&to->localClient->buf_sendq))
 	{
 		while ((retlen =
-			linebuf_flush(to->localClient->fd, &to->localClient->buf_sendq)) > 0)
+			linebuf_flush(to, to->localClient->fd, &to->localClient->buf_sendq)) > 0)
 		{
 			/* We have some data written .. update counters */
 #ifndef NDEBUG
@@ -323,6 +324,7 @@
 	/* Next, lets try to write some data */
 	if(to->localClient->slinkq)
 	{
+
 		retlen = send(to->localClient->ctrlfd,
 			      to->localClient->slinkq + to->localClient->slinkq_ofs,
 			      to->localClient->slinkq_len, 0);
diff -uNrd ircd-ratbox-1.3-1/src/ssl.c ircd-ratbox-1.3-1+fr-ssl/src/ssl.c
--- ircd-ratbox-1.3-1/src/ssl.c	Wed Dec 31 17:00:00 1969
+++ ircd-ratbox-1.3-1+fr-ssl/src/ssl.c	Sat Jan 24 13:57:08 2004
@@ -0,0 +1,185 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  ssl.c: Client ssl connections.
+ *
+ *  Copyright (C) 2003 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ * $Id: ssl.c,v 1.0 2003/12/03 21:22:43 Sakura Exp $
+ *
+ */
+
+#include "stdinc.h"
+#include "common.h"
+#include "s_conf.h"
+#include "db.h"
+#include "send.h"
+#include "s_bsd.h"
+
+#define SAFE_SSL_READ  1
+#define SAFE_SSL_WRITE  2
+#define SAFE_SSL_ACCEPT  3
+
+#ifdef HAVE_LIBCRYPTO
+
+static int fatal_ssl_error(int, int, struct Client *);
+
+int safe_SSL_read(struct Client *acptr, void *buf, int sz)
+{
+  int len, ssl_err;
+
+  len = SSL_read(acptr->ssl, buf, sz);
+
+  if (len <= 0) {
+    switch (ssl_err = SSL_get_error(acptr->ssl, len)) {
+      case SSL_ERROR_SYSCALL:
+        if (errno == EWOULDBLOCK || errno == EAGAIN || errno == EINTR) {
+      case SSL_ERROR_WANT_READ:
+        errno = EWOULDBLOCK;
+          return -1;
+        }
+      case SSL_ERROR_SSL:
+        if (errno == EAGAIN)
+          return -1;
+      default:
+        return fatal_ssl_error(ssl_err, SAFE_SSL_READ, acptr);
+    }
+  }
+  return len;
+}
+
+int safe_SSL_write(struct Client *acptr, const void *buf, int sz)
+{
+  int len, ssl_err;
+
+  len = SSL_write(acptr->ssl, buf, sz);
+  if (len <= 0) {
+    switch (ssl_err = SSL_get_error(acptr->ssl, len)) {
+      case SSL_ERROR_SYSCALL:
+        if (errno == EWOULDBLOCK || errno == EAGAIN || errno == EINTR) {
+      case SSL_ERROR_WANT_WRITE:
+        errno = EWOULDBLOCK;
+          return 0;
+        }
+      case SSL_ERROR_SSL:
+        if (errno == EAGAIN)
+          return 0;
+      default:
+        return fatal_ssl_error(ssl_err, SAFE_SSL_WRITE, acptr);
+    }
+  }
+  return len;
+}
+
+int safe_SSL_accept(struct Client *acptr, int fd)
+{
+
+  int ssl_err;
+
+  if ((ssl_err = SSL_accept(acptr->ssl)) <= 0) {
+    switch (ssl_err = SSL_get_error(acptr->ssl, ssl_err)) {
+      case SSL_ERROR_SYSCALL:
+        if (errno == EINTR || errno == EWOULDBLOCK || errno == EAGAIN)
+      case SSL_ERROR_WANT_READ:
+      case SSL_ERROR_WANT_WRITE:
+        /* handshake will be completed later . . */
+        return 1;
+      default:
+        return fatal_ssl_error(ssl_err, SAFE_SSL_ACCEPT, acptr);
+    }
+  /* NOTREACHED */
+  return 0;
+  }
+  return 1;
+}
+
+int SSL_smart_shutdown(SSL * ssl)
+{
+  int i;
+  int rc;
+
+  rc = 0;
+  for (i = 0; i < 4; i++) {
+    if ((rc = SSL_shutdown(ssl)))
+      break;
+  }
+
+  return rc;
+}
+
+static int fatal_ssl_error(int ssl_error, int where, struct Client *sptr)
+{
+  /* don't alter errno */
+  int errtmp = errno;
+  char *errstr = strerror(errtmp);
+  char *ssl_errstr, *ssl_func;
+
+  switch (where) {
+    case SAFE_SSL_READ:
+      ssl_func = "SSL_read()";
+      break;
+    case SAFE_SSL_WRITE:
+      ssl_func = "SSL_write()";
+      break;
+    case SAFE_SSL_ACCEPT:
+      ssl_func = "SSL_accept()";
+      break;
+    default:
+      ssl_func = "undefined SSL func [this is a bug]";
+  }
+
+  switch (ssl_error) {
+    case SSL_ERROR_NONE:
+      ssl_errstr = "No error";
+      break;
+    case SSL_ERROR_SSL:
+      ssl_errstr = "Internal OpenSSL error or protocol error";
+      break;
+    case SSL_ERROR_WANT_READ:
+      ssl_errstr = "OpenSSL functions requested a read()";
+      break;
+    case SSL_ERROR_WANT_WRITE:
+      ssl_errstr = "OpenSSL functions requested a write()";
+      break;
+    case SSL_ERROR_WANT_X509_LOOKUP:
+      ssl_errstr = "OpenSSL requested a X509 lookup which didn`t arrive";
+      break;
+    case SSL_ERROR_SYSCALL:
+      ssl_errstr = "Underlying syscall error";
+      break;
+    case SSL_ERROR_ZERO_RETURN:
+      ssl_errstr = "Underlying socket operation returned zero";
+      break;
+    case SSL_ERROR_WANT_CONNECT:
+      ssl_errstr = "OpenSSL functions wanted a connect()";
+      break;
+    default:
+      ssl_errstr = "Unknown OpenSSL error (huh?)";
+  }
+
+  /*
+  report_error(L_ADMIN, "%s to %s aborted with%serror (%s). [%s]",
+               ssl_func, get_client_name(sptr, SHOW_IP), (errno > 0) ? " " : " no ", errstr, ssl_errstr);
+  report_error(L_OPER, "%s to %s aborted with%serror (%s). [%s]",
+               ssl_func, get_client_name(sptr, MASK_IP), (errno > 0) ? " " : " no ", errstr, ssl_errstr);
+  */
+
+  errno = errtmp ? errtmp : EIO;  /* Stick a generic I/O error */
+  sptr->flags |= FLAGS_DEADSOCKET;
+  return 0;
+}
+#endif
diff -uNrd ircd-ratbox-1.3-1/src/tools.c ircd-ratbox-1.3-1+fr-ssl/src/tools.c
--- ircd-ratbox-1.3-1/src/tools.c	Wed Sep  3 09:46:29 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/tools.c	Sat Jan 24 14:07:23 2004
@@ -256,6 +256,11 @@
 	newlist->length++;
 }
 
+void dlinkDeleteNode(dlink_node *m, dlink_list *list)
+{
+    dlinkDelete(m, list);
+    free_dlink_node(m);
+}
 
 /*
  * init_dlink_nodes
diff -uNrd ircd-ratbox-1.3-1/src/version.c.SH ircd-ratbox-1.3-1+fr-ssl/src/version.c.SH
--- ircd-ratbox-1.3-1/src/version.c.SH	Sun Jul  6 08:01:03 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/version.c.SH	Sat Jan 24 12:34:36 2004
@@ -65,6 +65,7 @@
   "Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
   "Copyright (c) 1996-2001 Hybrid Development Team", 
   "Copyright (c) 2002-2003 ircd-ratbox Development Team",
+  "Copyright (c) 2004 FreeWorld Development Team",
   "",
   "This program is free software; you can redistribute it and/or",
   "modify it under the terms of the GNU General Public License as",
diff -uNrd ircd-ratbox-1.3-1/tools/public.key ircd-ratbox-1.3-1+fr-ssl/tools/public.key
--- ircd-ratbox-1.3-1/tools/public.key	Wed Dec 31 17:00:00 1969
+++ ircd-ratbox-1.3-1+fr-ssl/tools/public.key	Sat Jan 24 16:24:43 2004
@@ -0,0 +1,9 @@
+-----BEGIN PUBLIC KEY-----
+MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA1hNLQE+//uCVtqYAZJ5X
+C+jdgyCa9NHYI9Mus9RixEPsgoTOmEUWMCoOGoSEF2UPtL07iKvGsV39394vrw7G
+b+msHVmLLqJcRbeXNpxnwjoS0oOkkvv/NcpptKre5rLYeO1+WiwHxjbl/Blc315b
+UCJjaLvEHS56YtmZ0sW3emaHIGWvpr+mhUwB6aiKgWMunG9ZkHN9wcmx2R5UX3HR
+kGkfEwgCmXOQnZC9PG/2TdjEhmLHD0nHR+sy5yjvLEvRTC4AFzzB59wLWup/PJfH
+M2YIi3KYRbGT4dFFOQ/Ro40pDHeS3AThaikRnkwgX/zAd1op2bSG8W9xeOQiwjZg
+xQIDAQAB
+-----END PUBLIC KEY-----
